.data
    fibs: .word 0:12       # 定义一个存储斐波那契数的数组，初始化为12个元素的0
    size: .word 12         # 定义一个存储数组大小的变量，值为12
.text
    la $t0, fibs           # 将fibs数组的起始地址加载到寄存器$t0
    la $t5, size           # 将size变量的地址加载到寄存器$t5
    ld.w $t5, $t5, 0       # 将size变量的值加载到寄存器$t5（数组的小）
    li.w $t2, 1            # 将立即数1加载到寄存器$t2
    st.w $t2, $t0, 0       # fibs[0] = 1
    st.w $t2, $t0, 4       # fibs[1] = 1
    addi.w $t1, $t5, -2    # 将size减2存储到寄存器$t1（作为循环计数器）

loop:
    ld.w $t3, $t0, 0       # $t3 = fibs[n]
    ld.w $t4, $t0, 4       # $t4 = fibs[n+1]
    add.w $t2, $t3, $t4    # $t2 = fibs[n] + fibs[n+1]
    st.w $t2, $t0, 8       # Store fibs[n+2] = fibs[n] + fibs[n+1]
    addi.w $t0, $t0, 4     # 将$t0的值加4，指向数组的下一个元素
    addi.w $t1, $t1, -1    # 将循环计数器$t1减1
    bgtz $t1, loop         # 如果循环计数器$t1大于0，跳转到loop继续循环
    la $a0, fibs           # 将fibs数组的起始地址加载到寄存器$a0
    add.w $a1, $zero, $t5  # 将$t5（数组大小）加载到寄存器$a1
    b print                # 跳转到print标签

# print标签下的代码用于打印斐波那契数的标题
.data
    head: .asciz "The Fibonacci numbers are:"   # 定义斐波那契数的标题字符串
    space:.asciz " \n"                          # 定义一个字符串，包含一个空格
.text

print:
    add.w $t0, $zero, $a0  # 将$a0的值（fibs数组的地址）加载到寄存器$t0
    add.w $t1, $zero, $a1  # 将$a1的值（数组大小）加载到寄存器$t1

# out标签下的代码用于逐个打印斐波那契数
out:
    la $a0, head           # 将标题字符串的地址加载到寄存器$a7
    li.w $a7, 4            # 设置系统调用号为4（打印字符串）
    syscall 0
    ld.w $a0, $t0, 0       # 将$t0指向的数组元素的值加载到寄存器$a0
    li.w $a7, 1
    syscall 0
    la $a0, space          # 将空格字符串的地址加载到寄存器$a0
    li.w $a7, 4
    syscall 0
    addi.w $t0, $t0, 4
    addi.w $t1, $t1, -1
    bgtz $t1, out
    b exit                 # 如果所有斐波那契数都已打印完毕，则跳转到exit标签退出程序

exit:
    li.w $a7,10            # 设置系统调用号为10（退出程序）
    syscall 0              # 执行系统调用
