.data
	arrays:.word 0:12        # 定义数组arrays，包含12个4字节的元素
.text
	la $a6,arrays            # 将数组arrays的地址加载到寄存器$a6

getLength:
	li.w $a7, 5              # 设置系统调用号为5，这里假设5是读取数组长度的系统调用
	syscall 0                # 执行系统调用
	move $t0, $a0            # 将数组长度存储到$t0
	li.w $a2 0               # 设置计时器初始值
	move $a3 $a6             # 设置偏移量初始值

getNumber:
	beq $a2, $t0, deliverParam  # 如果读取完成 就进入排序
	li.w $a7 5                  # 读取数据
	syscall 0
	st.w $a0, $a3, 0         # 将数组存储到内存中
	addi.w $a3, $a3, 4       # 偏移量+4
	addi.w $a2, $a2, 1       # 计数+1
	b getNumber              # 继续循环

deliverParam:
	move $a0, $a6            # 将数组的地址加载到$a0
	move $a1, $t0            # 将数组长度加载到$a1
	b sort                   # 跳转到sort

#s0==i，s1==j，s2==v 地址初始值，s3==Length
sort:
    addi.w $sp, $sp, -20     # 为存储寄存器值在栈上分配空间
    st.w $ra, $sp, 16        # 将返回地址$ra压栈保存
    st.w $s3, $sp, 12        # 将$s3压栈保存
    st.w $s2, $sp, 8
    st.w $s1, $sp, 4
    st.w $s0, $sp, 0

    move $s2, $a0            # 将数组地址$a0保存到$s2
    move $s3, $a1
    li.w $s0, 0              # 初始化外层循环变量i为0

for1tst:  	#第一层循环
    slt  $t0, $s0, $s3       # if $s0 < $s3 (i < n) $t0 = 1
    beq  $t0, $zero, exit1    # if $t0 == 0, 即外层循环结束, 则跳转到exit1
    addi.w $s1, $s0, -1      # j = i – 1
    #记录当前的key=array[i]
    slli.w $t5, $s0, 2       # $t5 = $s0 * 4
    add.w $t6, $t5, $s2
    ld.w $t7, $t6, 0

for2tst:       #第二层循环
    slti $t0, $s1, 0         # $t0 = 1 if $s1 < 0 (j < 0)
    bne $t0, $zero, exit2    # if $s1 < 0，即内层循环结束，则跳转到exit2
    slli.w $t1, $s1, 2       # $t1 = j * 4
    add.w $t2, $s2, $t1      # $t2 = v + (j * 4)
    ld.w $t3, $t2, 0         # $t3 = v[j]
    ld.w $t4, $t2, 4         # $t4 = v[j + 1]
    slt $t0, $t4, $t3        # if $t4 < $t3 (v[j + 1] < v[j]) $t0 = 1
    beq $t0, $zero, exit2    # if $t4 >= $t3，即无需交换，则跳转到exit2
    bl swap                  # 调用swap过程进行交换
    addi.w $s1, $s1, -1      # j–-
    b for2tst                # 继续内层循环

swap:
	st.w $t3, $t2, 4         # 将$t3存储到v[j + 1]
    st.w $t4, $t2, 0         # 将$t4存储到v[j]
	jr $ra                   # 返回到调用swap的地方

exit2:
    addi.w $s0, $s0, 1       # i++
    slli.w $t5, $s1, 2
    add.w $t5, $t5, $s2
    st.w $t7, $t5, 4         # 将key存储到array[j+1]
    b for1tst                # 继续外层循环

exit1:
	#还原现场
    ld.w $s0, $sp, 0         # 从栈中恢复$s0
    ld.w $s1, $sp, 4
    ld.w $s2, $sp, 8
    ld.w $s3, $sp, 12
    ld.w $ra, $sp, 16
    addi.w $sp, $sp, 20
    #jirl $zero,$ra, 0       # return to calling routine
